% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/theme_element.R
\name{element_block}
\alias{element_block}
\title{Element block}
\usage{
element_block(
  post_space = c(NULL, " ", "-"),
  border = c(NULL, "outline", "bottom")
)
}
\arguments{
\item{post_space}{Option to create a new line after group block; specified characters will fill the cells}

\item{border}{Option to add a solid border to group block (rectangle or just bottom border)}
}
\value{
element block object
}
\description{
Element block
}
\examples{

tfrmt_spec <- tfrmt(
  group = grp1,
  label = label,
  param = param,
  value = value,
  column = column,
  row_grp_plan = row_grp_plan(
    row_grp_structure(group_val = ".default", element_block(post_space = "   "))
  ),
  body_plan = body_plan(
    frmt_structure(group_val = ".default", label_val = ".default", frmt("xx"))
  )
)
}
\seealso{
\code{\link[=row_grp_plan]{row_grp_plan()}} for more details on how to group row group
structures, \code{\link[=row_grp_structure]{row_grp_structure()}} for more details on how to specify row group
structures, \code{\link[=element_row_grp_loc]{element_row_grp_loc()}} for more details on how to
specify whether row group titles span the entire table or collapse.
}
